drama.shaders = {};
drama.shaders["lighten"] = {
	src: "varying mediump vec2 vTex;\nuniform lowp sampler2D samplerFront;\nuniform mediump vec2 srcStart;\nuniform mediump vec2 srcEnd;\nuniform lowp sampler2D samplerBack;\nuniform mediump vec2 destStart;\nuniform mediump vec2 destEnd;\n\nvoid main(void)\n{	lowp vec4 front = texture2D(samplerFront, vTex);\n	front.rgb /= front.a;\n	\n	mediump vec2 tex = (vTex - srcStart) / (srcEnd - srcStart);\n	lowp vec4 back = texture2D(samplerBack, mix(destStart, destEnd, tex));\n	back.rgb /= back.a;	front.rgb = max(front.rgb, back.rgb) * front.a;\n	\n	gl_FragColor = front * back.a;\n}\n",
	extendBoxHorizontal: 0,
	extendBoxVertical: 0,
	crossSampling: false,
	preservesOpaqueness: false,
	animated: false,
	parameters: []
};

drama.shaders["multiply"] = {
	src: "varying mediump vec2 vTex;\nuniform lowp sampler2D samplerFront;\nuniform mediump vec2 srcStart;\nuniform mediump vec2 srcEnd;\nuniform lowp sampler2D samplerBack;\nuniform mediump vec2 destStart;\nuniform mediump vec2 destEnd;\n\nvoid main(void)\n{	lowp vec4 front = texture2D(samplerFront, vTex);\n	\n	mediump vec2 tex = (vTex - srcStart) / (srcEnd - srcStart);\n	lowp vec4 back = texture2D(samplerBack, mix(destStart, destEnd, tex));    front *= back;\n	\n	gl_FragColor = front;\n}\n",
	extendBoxHorizontal: 0,
	extendBoxVertical: 0,
	crossSampling: false,
	preservesOpaqueness: false,
	animated: false,
	parameters: []
};

drama.shaders["overlay"] = {
	src: "precision mediump float;\n\nvarying mediump vec2 vTex;\nuniform lowp sampler2D samplerFront;\nuniform mediump vec2 srcStart;\nuniform mediump vec2 srcEnd;\nuniform lowp sampler2D samplerBack;\nuniform mediump vec2 destStart;\nuniform mediump vec2 destEnd;\n\nvoid main(void)\n{	lowp vec4 front = texture2D(samplerFront, vTex);\n	\n	mediump vec2 tex = (vTex - srcStart) / (srcEnd - srcStart);\n	lowp vec4 back = texture2D(samplerBack, mix(destStart, destEnd, tex));\n	\n	front.r = back.r < 0.5 ? 2.0 * back.r * front.r : 2.0 * (front.r + back.r * front.a - back.r * front.r) - front.a;\n	front.g = back.g < 0.5 ? 2.0 * back.g * front.g : 2.0 * (front.g + back.g * front.a - back.g * front.g) - front.a;\n	front.b = back.b < 0.5 ? 2.0 * back.b * front.b : 2.0 * (front.b + back.b * front.a - back.b * front.b) - front.a;\n	front *= back.a;\n	\n	gl_FragColor = front;\n}\n",
	extendBoxHorizontal: 0,
	extendBoxVertical: 0,
	crossSampling: false,
	preservesOpaqueness: false,
	animated: false,
	parameters: []
};

drama.shaders["setcolor"] = {
	src: "varying mediump vec2 vTex;\nuniform lowp sampler2D samplerFront;\nuniform lowp vec3 setColor;\n\nvoid main(void)\n{\n	lowp float a = texture2D(samplerFront, vTex).a;\n	\n	gl_FragColor = vec4(setColor.r * a, setColor.g * a, setColor.b * a, a);\n}\n",
	extendBoxHorizontal: 0,
	extendBoxVertical: 0,
	crossSampling: false,
	preservesOpaqueness: true,
	animated: false,
	parameters: [["setColor",0,2]]
};
